/*
  ==============================================================================

  This is an automatically generated file created by the Jucer!

  Creation date:  20 Sep 2011 4:17:01pm

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Jucer version: 1.12

  ------------------------------------------------------------------------------

  The Jucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-6 by Raw Material Software ltd.

  ==============================================================================
*/

//[Headers] You can add your own extra header files here...
#include "monitor.h"
//[/Headers]

#include "msgGraphic.h"


//[MiscUserDefs] You can add your own user definitions and misc code here...
//[/MiscUserDefs]

//==============================================================================
msgGraphic::msgGraphic ()
{

    //[UserPreSize]
    //[/UserPreSize]

    setSize (288, 400);

    //[Constructor] You can add your own custom stuff here..
    r_nMsgs=0;
    r_msgLog = new XmlElement("msgLog");

    //[/Constructor]
}

msgGraphic::~msgGraphic()
{
    //[Destructor_pre]. You can add your own custom destruction code here..
    //[/Destructor_pre]



    //[Destructor]. You can add your own custom destruction code here..
    //[/Destructor]
}

//==============================================================================
void msgGraphic::paint (Graphics& g)
{
    //[UserPrePaint] Add your own custom painting code here..
    //[/UserPrePaint]

    g.fillAll (Colours::white);

    //[UserPaint] Add your own custom painting code here..

    int vPosition=20;

    if (r_msgLog->hasTagName("msgLog"))
    {
		forEachXmlChildElement (*r_msgLog, e)
		{
		   if (e->hasTagName("msg"))
		   {
			   g.setColour (Colour::fromRGB(0x00,0x00,0x00));
			   g.setFont(12,0);
			   g.drawText(e->getStringAttribute("timeStamp"),5,vPosition-5,90,24,Justification::topLeft,false);

			   if (e->getStringAttribute("direction")=="out"){
				   g.setColour (Colour::fromRGB(0x2A,0x8E,0xA5));
				   g.drawArrow(Line<float>(105,vPosition,225,vPosition+10),1,10,10);
			   }
			   else{
				   g.setColour (Colour::fromRGB(0xA5,0x2A,0x2A));
				   g.drawArrow(Line<float>(225,vPosition,105,vPosition+10),1,10,10);
			   }

			   g.setColour (Colour::fromRGB(0x00,0x00,0x00));
			   g.drawText(e->getStringAttribute("name"),105,vPosition-18,120,24,Justification::centred,false);

			   vPosition += 32;
		   }
		}
    }

    if (vPosition<250){
    	vPosition=250;
    }

    g.setColour (Colour (0xff2a8ea5));
    g.drawVerticalLine(105,0,vPosition);
    g.drawVerticalLine(225,0,vPosition);
    setSize(288,vPosition);

    //[/UserPaint]
}

void msgGraphic::resized()
{
    //[UserResized] Add your own custom resize handling here..
    //[/UserResized]
}



//[MiscUserCode] You can add your own definitions of your custom methods or any other code here...
void msgGraphic::appendMsg(String name, String timeStamp, String fileName, String direction){

	if (r_nMsgs<_MAX_MSGS_LOGGED_){
		Image * selectImage=new Image(Image::RGB,1,1,false);
		selectImage->clear(Rectangle<int>(0,0,1,1),Colour(0xFFFFFFFF));

		XmlElement* newMsg = new XmlElement("msg");
		newMsg->setAttribute("name",name);
		newMsg->setAttribute("timeStamp",timeStamp);
		newMsg->setAttribute("file",fileName);
		newMsg->setAttribute("direction",direction);
		r_msgLog->addChildElement (newMsg);

		addAndMakeVisible (r_ArrayButtons[r_nMsgs] = new ImageButton (T("b_Button")));
		r_ArrayButtons[r_nMsgs]->addListener (this);
		r_ArrayButtons[r_nMsgs]->setBounds(0,5+r_nMsgs*32,270,32);

		r_ArrayButtons[r_nMsgs]->setImages(false,true,false,
				*selectImage,0.0000f, Colour(0),
				*selectImage,0.1000f, Colour(0x20500000),
				*selectImage,0.3000f, Colour(0x50500000)
				);

		r_nMsgs++;

	}else{
		AlertWindow("Too many messages", "Try to restart log to register new messages.",AlertWindow::WarningIcon);
	}
}

int msgGraphic::getSelectedMsg(){
	return r_selectedMsg;
}


void msgGraphic::buttonClicked (Button* buttonThatWasClicked){

	for (int i=0;i<r_nMsgs;i++){
		if (buttonThatWasClicked==r_ArrayButtons[i]){
			r_selectedMsg = i;
			r_ArrayButtons[i]->setToggleState(false,false);
//			r_ArrayButtons[i]->setState(Button::buttonDown);
			findParentComponentOfClass<monitor>()->postCommandMessage(_update_fieldMonitor_);
			break;
//		}else{
//			r_ArrayButtons[i]->setToggleState(false,false);
//			r_ArrayButtons[i]->setState(Button::buttonNormal);
//		}
		}

	}
}

void msgGraphic::deleteAllMessages(){

	r_msgLog->deleteAllChildElements();
	for (int i=0;i<r_nMsgs;i++){
		delete r_ArrayButtons[i];
	}

	r_nMsgs = 0;

	repaint();
}

String msgGraphic::getMsgName(int index){
	int cnt = 0;

	forEachXmlChildElement (*r_msgLog, e) {
		if (e->hasTagName("msg")) {
			if (cnt==index){
				return e->getStringAttribute("name");
			}
			cnt++;
		}
	}

	return "";
}

String msgGraphic::getMsgFile(int index){
	int cnt = 0;

	forEachXmlChildElement (*r_msgLog, e) {
		if (e->hasTagName("msg")) {
			if (cnt==index){
				return e->getStringAttribute("file");
			}
			cnt++;
		}
	}

	return "";
}

String msgGraphic::getMsgTimeStamp(int index){
	int cnt = 0;

		forEachXmlChildElement (*r_msgLog, e) {
			if (e->hasTagName("msg")) {
				if (cnt==index){
					return e->getStringAttribute("timeStamp");
				}
				cnt++;
			}
		}

		return "";
}

void msgGraphic::saveLog(File fileDescriptor){
	r_msgLog->writeToFile(fileDescriptor,"");
}

void msgGraphic::loadLog(File fileDescriptor){


	deleteAllMessages();

	XmlDocument myDocument(fileDescriptor);
	r_msgLog = myDocument.getDocumentElement();
	if (r_msgLog == 0)
	{
		AlertWindow::showNativeDialogBox("INVALID LOG FILE","Try to load other file",false);
	}else{
		Image * selectImage=new Image(Image::RGB,1,1,false);
		selectImage->clear(Rectangle<int>(0,0,1,1),Colour(0xFFFFFFFF));

		forEachXmlChildElement (*r_msgLog, e)
    	{
			if (e->hasTagName ("msg"))
			{
				addAndMakeVisible (r_ArrayButtons[r_nMsgs] = new ImageButton (T("b_Button")));
				r_ArrayButtons[r_nMsgs]->addListener (this);
				r_ArrayButtons[r_nMsgs]->setBounds(0,5+r_nMsgs*32,270,32);

				r_ArrayButtons[r_nMsgs]->setImages(false,true,false,
						*selectImage,0.0000f, Colour(0),
						*selectImage,0.1000f, Colour(0x20500000),
						*selectImage,0.3000f, Colour(0x50500000)
						);

				r_ArrayButtons[r_nMsgs]->setClickingTogglesState(true);
				r_nMsgs++;
			}
    	}

	}

}
//[/MiscUserCode]


//==============================================================================
#if 0
/*  -- Jucer information section --

    This is where the Jucer puts all of its metadata, so don't change anything in here!

BEGIN_JUCER_METADATA

<JUCER_COMPONENT documentType="Component" className="msgGraphic" componentName=""
                 parentClasses="public Component" constructorParams="" variableInitialisers=""
                 snapPixels="8" snapActive="1" snapShown="1" overlayOpacity="0.330000013"
                 fixedSize="1" initialWidth="288" initialHeight="400">
  <BACKGROUND backgroundColour="ffffffff"/>
</JUCER_COMPONENT>

END_JUCER_METADATA
*/
#endif
